/* file for all SCSI commands
 * FUA (Force Unit Access) bit handling copied from Monty's cdparanoia.
 */

#include "config.h"
#include <standard.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <btorder.h>
#define        g5_cdblen(cdb, len)     ((cdb)->count[0] = (len) >> 24L,\
                                (cdb)->count[1] = ((len) >> 16L)& 0xFF,\
                                (cdb)->count[2] = ((len) >> 8L) & 0xFF,\
                                (cdb)->count[3] = (len) & 0xFF)

#define        g5x_cdblen(cdb, len)    ((cdb)->count[0] = ((len) >> 16L)& 0xFF,\
                                (cdb)->count[1] = ((len) >> 8L) & 0xFF,\
                                (cdb)->count[2] = (len) & 0xFF)



#include <scgio.h>
#include <scsidefs.h>
#include <scsireg.h>

#include "cdda2wav.h"
#include "interface.h"
#include "byteorder.h"
#include "global.h"
#include "cdrecord.h"
#include "scsi_cmds.h"

#include <scsitransp.h>

unsigned char *bufferTOC;
subq_chnl *SubQbuffer;
unsigned char *cmd;
int adjust_ssize;

int SCSI_emulated_ATAPI_on(scgp)
	SCSI *scgp;
{
/*	return is_atapi;*/
	if (scsi_isatapi(scgp) > 0)
		return (TRUE);

	(void) allow_atapi(scgp, TRUE);
	return (allow_atapi(scgp, TRUE));
}

int heiko_mmc(scgp)
	SCSI *scgp;
{
        unsigned char	mode[0x100];
	int		was_atapi;
        struct  cd_mode_page_2A *mp;
	int retval;

        fillbytes((caddr_t)mode, sizeof(mode), '\0');

        was_atapi = allow_atapi(scgp, 1);
        scgp->silent++;
        mp = mmc_cap(scgp, mode);
        scgp->silent--;
        allow_atapi(scgp, was_atapi);
        if (mp == NULL)
                return (0);

        /* have a look at the capabilities */
	if (mp->cd_da_supported == 0) {
	  retval = -1;
	} else {
	  retval = 1 + mp->cd_da_accurate;
        }
	return retval;
}


int accepts_fua_bit;
unsigned char density = 0;
unsigned char orgmode4 = 0;
unsigned char orgmode10, orgmode11;

/* get current sector size from SCSI cdrom drive */
unsigned int 
get_orig_sectorsize(scgp, m4, m10, m11)
	SCSI *scgp;
	unsigned char *m4;
	unsigned char *m10; 
	unsigned char *m11;
{
      /* first get current values for density, etc. */

      static unsigned char *modesense = NULL;
   
      if (modesense == NULL) {
        modesense = (unsigned char *) malloc(12);
        if (modesense == NULL) {
          fprintf(stderr, "Cannot allocate memory for mode sense command in line %d\n", __LINE__);
          return 0;
        }
      }

      /* do the scsi cmd */
      if (scgp->verbose) fprintf(stderr, "\nget density and sector size...");
      if (mode_sense(scgp, modesense, 12, 0x01, 0) < 0)
	  perror ("get_orig_sectorsize mode sense failed\n");

      /* FIXME: some drives dont deliver block descriptors !!! */
      if (modesense[3] == 0)
        return 0;

      if (m4 != NULL)                       /* density */
        *m4 = modesense[4];
      if (m10 != NULL)                      /* MSB sector size */
        *m10 = modesense[10];
      if (m11 != NULL)                      /* LSB sector size */
        *m11 = modesense[11];

      return (modesense[10] << 8) + modesense[11];
}



/* switch CDROM scsi drives to given sector size  */
int set_sectorsize (scgp, secsize, set_density)
	SCSI *scgp;
	unsigned int secsize;
	int set_density;
{
  /* reserved, Medium type=0, Dev spec Parm = 0, block descriptor len 0 oder 8,
     Density (cd format) 
     (0=YellowBook, XA Mode 2=81h, XA Mode1=83h and raw audio via SCSI=82h),
     # blks msb, #blks, #blks lsb, reserved,
     blocksize, blocklen msb, blocklen lsb,
   */

  /* MODE_SELECT, page = SCSI-2  save page disabled, reserved, reserved, 
     parm list len, flags */
  static unsigned char mode [4 + 8];
  int retval;

  if (orgmode4 == 0xff) {
    get_orig_sectorsize(scgp, &orgmode4, &orgmode10, &orgmode11);
  }

  if (orgmode4 == 0x82 && secsize == 2048)
    orgmode4 = 0x81;

  /* prepare to read cds in the previous mode */

  fillbytes((caddr_t)mode, sizeof(mode), '\0');
  mode[ 3] = 8; 	       /* Block Descriptor Length */
  mode[ 4] = orgmode4; 	       /* normal density */
  mode[10] =  secsize >> 8;   /* block length "msb" */
  mode[11] =  secsize & 0xFF; /* block length lsb */

  if (scgp->verbose) fprintf(stderr, "\nset density and sector size...");
  /* do the scsi cmd */
  if ((retval = mode_select(scgp, mode, 12, 0, scgp->inq->data_format >= 2)) < 0)
        perror ("setting sector size failed\n");

  return retval;
}


/* switch Toshiba/DEC and HP drives from/to cdda density */
void EnableCddaModeSelect (scgp, fAudioMode)
	SCSI *scgp;
	int fAudioMode;
{
  /* reserved, Medium type=0, Dev spec Parm = 0, block descriptor len 0 oder 8,
     Density (cd format) 
     (0=YellowBook, XA Mode 2=81h, XA Mode1=83h and raw audio via SCSI=82h),
     # blks msb, #blks, #blks lsb, reserved,
     blocksize, blocklen msb, blocklen lsb,
   */

  /* MODE_SELECT, page = SCSI-2  save page disabled, reserved, reserved, 
     parm list len, flags */
  static unsigned char mode [4 + 8] = { 
       /* mode section */
			    0, 
                            0, 0, 
                            8,       /* Block Descriptor Length */
       /* block descriptor */
                            0,       /* Density Code */
                            0, 0, 0, /* # of Blocks */
                            0,       /* reserved */
                            0, 0, 0};/* Blocklen */

  if (orgmode4 == 0 && fAudioMode) {
    if (0 == get_orig_sectorsize(scgp, &orgmode4, &orgmode10, &orgmode11)) {
        /* cannot retrieve density, sectorsize */
	orgmode10 = (CD_FRAMESIZE >> 8L);
	orgmode11 = (CD_FRAMESIZE & 0xFF);
    }
  }

  if (fAudioMode) {
    /* prepare to read audio cdda */
    mode [4] = density;  			/* cdda density */
    mode [10] = (CD_FRAMESIZE_RAW >> 8L);   /* block length "msb" */
    mode [11] = (CD_FRAMESIZE_RAW & 0xFF);
  } else {
    /* prepare to read cds in the previous mode */
    mode [4] = orgmode4; /* 0x00; 			\* normal density */
    mode [10] = orgmode10; /* (CD_FRAMESIZE >> 8L);  \* block length "msb" */
    mode [11] = orgmode11; /* (CD_FRAMESIZE & 0xFF); \* block length lsb */
  }

  if (scgp->verbose) fprintf(stderr, "\nset density and sector size (EnableCddaModeSelect)...\n");
  /* do the scsi cmd */
  if (mode_select(scgp, mode, 12, 0, scgp->inq->data_format >= 2) < 0)
        perror ("Audio mode switch failed\n");
}

#define DEBUG_CDTEXT

typedef struct {
unsigned char headerfield[4];
unsigned char textdatafield[12];
unsigned char crcfield[2];
} cdtextpackdata;

/* read CD Text information from the table of contents */
void ReadTocTextSCSI ( scgp )
	SCSI *scgp;
{
    short int datalength;
    unsigned char *p = bufferTOC;

  /* READTOC, MSF, format, res, res, res, Start track/session, len msb,
     len lsb, control */
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = 4;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x43;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.addr[0] = 5;
        scmd->cdb.g1_cdb.res6 = 1;
        g1_cdblen(&scmd->cdb.g1_cdb, 4);

        scgp->silent++;
        if (scgp->verbose) fprintf(stderr, "\nRead TOC CD Text size ...");

	scgp->cmdname = "read toc size (text)";

        if (scsicmd(scgp) < 0) {
          scgp->silent--;
	  if (global.quiet != 1)
            fprintf (stderr, "Read TOC CD Text failed (probably not supported).\n");
          return ;
        }
        scgp->silent--;

    datalength  = (p[0] << 8) | (p[1]);
    if (datalength <= 2) return;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = 2+datalength;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x43;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.addr[0] = 5;
        scmd->cdb.g1_cdb.res6 = 1;
        g1_cdblen(&scmd->cdb.g1_cdb, 2+datalength);

        scgp->silent++;
        if (scgp->verbose) fprintf(stderr, "\nRead TOC CD Text data ...");

	scgp->cmdname = "read toc data (text)";

        if (scsicmd(scgp) < 0) {
          scgp->silent--;
	  if (global.quiet != 1)
            fprintf (stderr,  "Read TOC CD Text data failed (probably not supported).\n");
          return ;
        }
        scgp->silent--;

  /* interpret the contents of CD Text information based on an early draft
     of SCSI-3 mmc version 2 from jan 2, 1998
     CD Text information consists of a text group containing up to
     8 language blocks containing up to
     255 Pack data chunks of
     18 bytes each.
     So we have at most 36720 bytes to cope with.
   */
  {
    datalength -= 2;
    p += 4;
    while (datalength > 0) {
      /* handle one packet of CD Text Information Descriptor Pack Data */
      /* this is raw R-W subchannel data converted to 8 bit values. */
      cdtextpackdata *c = (cdtextpackdata *)p;
      int bin_print=1;
      int extension_flag;
      int sequence_number;
      int dbcc;
      int block_number;
      int character_position;

      datalength -= sizeof (cdtextpackdata);
      p += sizeof (cdtextpackdata);

      extension_flag = (c->headerfield[1] & 0x80) >> 7;
      c->headerfield[1] &= 0x7f;
      sequence_number = c->headerfield[2];
      dbcc = (c->headerfield[3] & 0x80) >> 7; /* double byte character code */
      block_number = (c->headerfield[3] & 0x30) >> 4; /* language */
      character_position = c->headerfield[3] & 0x0f;
#if defined DEBUG_CDTEXT
      fprintf(stderr, "CDText: ext_fl=%d, seq_nr=%d, dbcc=%d, block_nr=%d, char_pos=%d\n",
             extension_flag, sequence_number, dbcc, block_number, character_position);
#endif
      switch (c->headerfield[0]) {

        case 0x80: /* Title of album or track */
          if (c->headerfield[1] == 0) {
            fprintf (stderr, "album title: ");
          } else {
            fprintf(stderr, "title for track %u: ", c->headerfield[1]);
          }
          bin_print = 0;
        break;
        case 0x81: /* Name(s) of the performer(s) */
          fprintf(stderr, "Performer(s): ");
          bin_print = 0;
        break;
        case 0x82: /* Name(s) of the songwriter(s) */
          fprintf(stderr, "Songwriter(s): ");
          bin_print = 0;
        break;
        case 0x83: /* Name(s) of the composer(s) */
          fprintf(stderr, "Composer(s): ");
          bin_print = 0;
        break;
        case 0x84: /* Name(s) of the arranger(s) */
          fprintf(stderr, "Arranger(s): ");
          bin_print = 0;
        break;
        case 0x85: /* Message from content provider and/or artist */
          fprintf(stderr, "Message: ");
          bin_print = 0;
        break;
        case 0x86: /* Disc Identification and information */
          fprintf(stderr, "Disc identification: ");
          bin_print = 1;
        break;
        case 0x87: /* Genre Identification and information */
          fprintf(stderr, "Genre identification: ");
          bin_print = 1;
        break;
        case 0x88: /* Table of Content information */
          fprintf(stderr, "Table of Content identification: ");
          bin_print = 1;
        break;
        case 0x89: /* Second Table of Content information */
          fprintf(stderr, "Second Table of Content identification: ");
          bin_print = 1;
        break;
        case 0x8e: /* UPC/EAN code or ISRC code */
          fprintf(stderr, "UPC or ISRC: ");
          bin_print = 1;
        break;
        case 0x8f: /* Size information of the block */
          fprintf(stderr, "size of block: ");
          bin_print = 1;
        break;
#if !defined DEBUG_CDTEXT
        default:
#else
      }
#endif
          fprintf(stderr, "Reserved Pack Type Indicators %02x %02x %02x\n",
                          c->headerfield[0], c->headerfield[1], c->headerfield[2]);
#if !defined DEBUG_CDTEXT
          bin_print = 1;
      }
      if (dbcc != 0 || bin_print != 0) {
#else
      {
#endif
          fprintf(stderr,
"%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n"
                        , c->textdatafield[0]
                        , c->textdatafield[1]
                        , c->textdatafield[2]
                        , c->textdatafield[3]
                        , c->textdatafield[4]
                        , c->textdatafield[5]
                        , c->textdatafield[6]
                        , c->textdatafield[7]
                        , c->textdatafield[8]
                        , c->textdatafield[9]
                        , c->textdatafield[10]
                        , c->textdatafield[11]
                 );
      }
      if (dbcc == 0 && bin_print == 0) {
        /* print ASCII information */
        fprintf (stderr, "%12.12s\n", c->textdatafield);
      }
    }
  }
}

/* read the start of the lead-out from the first session TOC */
unsigned ReadFirstSessionTOCSony ( scgp, tracks )
	SCSI *scgp;
	unsigned tracks;
{
  /* READTOC, MSF, format, res, res, res, Start track/session, len msb,
     len lsb, control */
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = 4 + (tracks + 3) * 11;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x43;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.res = 1;
        scmd->cdb.g1_cdb.res6 = 1;    /* session */
        g1_cdblen(&scmd->cdb.g1_cdb, 4 + (tracks + 3) * 11);
        scmd->cdb.g1_cdb.vu_97 = 1;   /* format */

        scgp->silent++;
        if (scgp->verbose) fprintf(stderr, "\nRead TOC first session ...");

	scgp->cmdname = "read toc first session";

        if (scsicmd(scgp) < 0) {
          scgp->silent--;
	  if (global.quiet != 1)
            fprintf (stderr, "Read TOC first session failed (probably not supported).\n");
          return 0;
        }
        scgp->silent--;

        if ((unsigned)((bufferTOC[0] << 8) | bufferTOC[1]) >= 4 + (tracks + 3) * 11 -2) {
          unsigned off;

          /* We want the entry with POINT = 0xA2, which has the start position
             of the first session lead out */
          off = 4 + 2 * 11 + 3;
          if (bufferTOC[off-3] == 1 && bufferTOC[off] == 0xA2) {
            unsigned retval;

            off = 4 + 2 * 11 + 8;
            retval = bufferTOC[off] >> 4;
	    retval *= 10; retval += bufferTOC[off] & 0xf;
	    retval *= 60;
	    off++;
            retval += 10 * (bufferTOC[off] >> 4) + (bufferTOC[off] & 0xf);
	    retval *= 75;
	    off++;
            retval += 10 * (bufferTOC[off] >> 4) + (bufferTOC[off] & 0xf);
	    retval -= 150;

            return retval;
          }
        }
        return 0;
}

/* read the start of the lead-out from the first session TOC */
unsigned ReadFirstSessionTOCMMC ( scgp, tracks )
	SCSI *scgp;
	unsigned tracks;
{

  /* READTOC, MSF, format, res, res, res, Start track/session, len msb,
     len lsb, control */
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = 4 + (tracks + 3) * 11;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x43;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.res = 1;
        scmd->cdb.g1_cdb.addr[0] = 2; /* format */
        scmd->cdb.g1_cdb.res6 = 1;    /* session */
        g1_cdblen(&scmd->cdb.g1_cdb, 4 + (tracks + 3) * 11);

        scgp->silent++;
        if (scgp->verbose) fprintf(stderr, "\nRead TOC first session ...");

	scgp->cmdname = "read toc first session";

        if (scsicmd(scgp) < 0) {
          scgp->silent--;
	  if (global.quiet != 1)
            fprintf (stderr, "Read TOC first session failed (probably not supported).\n");
          return 0;
        }
        scgp->silent--;

        if ((unsigned)((bufferTOC[0] << 8) | bufferTOC[1]) >= 4 + (tracks + 3) * 11 - 2) {
          unsigned off;

          /* We want the entry with POINT = 0xA2, which has the start position
             of the first session lead out */
          off = 4 + 3;
          while (off < 4 + (tracks + 3) * 11 && bufferTOC[off] != 0xA2) {
            off += 11;
          }
          if (off < 4 + (tracks + 3) * 11) {
            off += 5;
            return (bufferTOC[off]*60 + bufferTOC[off+1])*75 + bufferTOC[off+2] - 150;
          }
        }
        return 0;
}

/* read the table of contents from the cd and fill the TOC array */
unsigned ReadTocSCSI ( scgp, toc )
	SCSI *scgp;
	TOC *toc;
{
  unsigned i;
  unsigned tracks;

  /* READTOC, MSF format flag, res, res, res, res, Start track, len msb,
     len lsb, flags */
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = 4;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x43;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.addr[0] = 0;
        scmd->cdb.g1_cdb.res6 = 1;
        g1_cdblen(&scmd->cdb.g1_cdb, 4);

        if (scgp->verbose) fprintf(stderr, "\nRead TOC size (standard)...");
  /* do the scsi cmd (read table of contents) */

	scgp->cmdname = "read toc size";
  if (scsicmd(scgp) < 0)
      FatalError ("Read TOC size failed.\n");


  tracks = ((bufferTOC [3] ) - bufferTOC [2] + 2) ;
  if (tracks > MAXTRK) return 0;
  if (tracks == 0) return 0;


	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = 4 + tracks * 8;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x43;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.addr[0] = 0;
        scmd->cdb.g1_cdb.res6 = 1;
        g1_cdblen(&scmd->cdb.g1_cdb, 4 + tracks * 8);

        if (scgp->verbose) fprintf(stderr, "\nRead TOC tracks (standard)...");
  /* do the scsi cmd (read table of contents) */

	scgp->cmdname = "read toc tracks ";

  if (scsicmd(scgp) < 0)
      FatalError ("Read TOC tracks failed.\n");

  /* copy to our structure and convert start sector */
  for (i = 0; i < tracks; i++) {
      memcpy (&toc[i], bufferTOC + 4 + 8*i, 8);
      toc[i].ISRC[0] = 0;
      toc[i].dwStartSector = adjust_ssize * be32_to_cpu(toc[i].dwStartSector);
      if ( toc [i].bTrack != i+1 )
	  toc [i].bTrack = i+1;
  }
  ReadTocTextSCSI(scgp);
  return --tracks;           /* without lead-out */
}

/* a contribution from Boris for IMS cdd 522 */

/* read the table of contents from the cd and fill the TOC array */
unsigned ReadTocCdrSCSI ( scgp, toc )
	SCSI *scgp;
	TOC *toc;
{
  unsigned i;
  unsigned tracks;
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = CD_FRAMESIZE;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0xE5;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        g1_cdbaddr(&scmd->cdb.g1_cdb, 1);
        g1_cdblen(&scmd->cdb.g1_cdb, CD_FRAMESIZE);

        if (scgp->verbose) fprintf(stderr, "\nRead TOC (philips)...");
  /* do the scsi cmd (read table of contents) */

	scgp->cmdname = "read track info philips";

  if (scsicmd(scgp) < 0)
      FatalError ("Read TrackInfo failed.\n");

  tracks = bufferTOC[1];
  if (tracks > MAXTRK) return 0;
  if (tracks == 0) return 0;

  /* copy to our structure and convert start sector */
  for (i = 0; i < tracks; i++)
    {
	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)bufferTOC;
        scmd->size = CD_FRAMESIZE;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0xE5;
        scmd->cdb.g1_cdb.lun = scgp->lun;
        g1_cdbaddr(&scmd->cdb.g1_cdb, i + 1);
        g1_cdblen(&scmd->cdb.g1_cdb, CD_FRAMESIZE);

	scgp->cmdname = "read track info philips";

      if (scsicmd(scgp) < 0)
          FatalError ("Read TrackInfo failed.\n");

      toc[i].reserved1 = 0;
      toc[i].bFlags = bufferTOC[10];
      toc[i].bTrack = i + 1;
      toc[i].reserved2 = 0;
      toc[i].dwStartSector = adjust_ssize * be32_to_cpu(GET_UINT_FROM_CHARP(bufferTOC+2));
      toc[i].ISRC[0] = 0;
      if ( toc [i].bTrack != i+1 )
	  toc [i].bTrack = i+1;
    }

  toc[i].reserved1 = 0;
  toc[i].bFlags = 0;
  toc[i].bTrack = i + 1;
  toc[i].reserved2 = 0;
  toc[i].dwStartSector = adjust_ssize * (be32_to_cpu(GET_UINT_FROM_CHARP(bufferTOC + 2)) +
                                        be32_to_cpu(GET_UINT_FROM_CHARP(bufferTOC + 6)));
  toc[i].ISRC[0] = 0;

  ReadTocTextSCSI(scgp);
  return tracks;
}

/* Read max. SectorBurst of cdda sectors to bufferCdda
   via standard SCSI-2 Read(10) command */
void ReadStandard (scgp, p, lSector, SectorBurstVal )
	SCSI *scgp;
	UINT4 *p;
	unsigned lSector;
	unsigned SectorBurstVal;
{
  /* READ10, flags, block1 msb, block2, block3, block4 lsb, reserved, 
     transfer len msb, transfer len lsb, block addressing mode */
  int count = 0;
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)p;
        scmd->size = SectorBurstVal*CD_FRAMESIZE_RAW;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x28;
        scmd->cdb.g1_cdb.lun = scgp->lun;
	scmd->cdb.g1_cdb.res |= (accepts_fua_bit == 1 ? 1 << 2 : 0);
        g1_cdbaddr(&scmd->cdb.g1_cdb, lSector);
        g1_cdblen(&scmd->cdb.g1_cdb, SectorBurstVal);
        if (scgp->verbose) fprintf(stderr, "\nReadStandard10 CDDA...");

	scgp->cmdname = "ReadStandard10";

  while (scsicmd(scgp) < 0
	 && count--)
    ;
  if (count < 0)
    FatalError ("Read CD-ROM10 failed\n");
}


/* Read max. SectorBurst of cdda sectors to bufferCdda
   via vendor-specific ReadCdda(10) command */
void ReadCdda10 (scgp, p, lSector, SectorBurstVal )
	SCSI *scgp;
	UINT4 *p;
	unsigned lSector;
	unsigned SectorBurstVal;
{
  /* READ10, flags, block1 msb, block2, block3, block4 lsb, reserved, 
     transfer len msb, transfer len lsb, block addressing mode */
  int count = 0;
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)p;
        scmd->size = SectorBurstVal*CD_FRAMESIZE_RAW;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0xd4;
        scmd->cdb.g1_cdb.lun = scgp->lun;
	scmd->cdb.g1_cdb.res |= (accepts_fua_bit == 1 ? 1 << 2 : 0);
        g1_cdbaddr(&scmd->cdb.g1_cdb, lSector);
        g1_cdblen(&scmd->cdb.g1_cdb, SectorBurstVal);
        if (scgp->verbose) fprintf(stderr, "\nReadNEC10 CDDA...");

	scgp->cmdname = "Read10 NEC";

  while (scsicmd(scgp) < 0
	 && count--)
    ;
  if (count < 0)
    FatalError ("Read CD-ROM10 (NEC) failed\n");
}


/* Read max. SectorBurst of cdda sectors to bufferCdda
   via vendor-specific ReadCdda(12) command */
void ReadCdda12 (scgp, p, lSector, SectorBurstVal )
	SCSI *scgp;
	UINT4 *p;
	unsigned lSector;
	unsigned SectorBurstVal;
{
  int count = 0;
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)p;
        scmd->size = SectorBurstVal*CD_FRAMESIZE_RAW;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G5_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g5_cdb.cmd = 0xD8;
        scmd->cdb.g5_cdb.lun = scgp->lun;
	scmd->cdb.g5_cdb.res |= (accepts_fua_bit == 1 ? 1 << 2 : 0);
        g5_cdbaddr(&scmd->cdb.g5_cdb, lSector);
        g5_cdblen(&scmd->cdb.g5_cdb, SectorBurstVal);

        if (scgp->verbose) fprintf(stderr, "\nReadSony12 CDDA...");

	scgp->cmdname = "Read12";

  while (scsicmd(scgp) < 0
	 && count--)
    ;
  if (count < 0)
    FatalError ("Read CD-ROM12 failed\n");
}

/* Read max. SectorBurst of cdda sectors to bufferCdda
   via vendor-specific ReadCdda(12) command */
/*
> It uses a 12 Byte CDB with 0xd4 as opcode, the start sector is coded as
> normal and the number of sectors is coded in Byte 8 and 9 (begining with 0).
*/

void ReadCdda12Matsushita (scgp, p, lSector, SectorBurstVal )
	SCSI *scgp;
	UINT4 *p;
	unsigned lSector;
	unsigned SectorBurstVal;
{
  int count = 0;
	register struct	scg_cmd	*scmd = scgp->scmd;

        fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)p;
        scmd->size = SectorBurstVal*CD_FRAMESIZE_RAW;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G5_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g5_cdb.cmd = 0xD4;
        scmd->cdb.g5_cdb.lun = scgp->lun;
	scmd->cdb.g5_cdb.res |= (accepts_fua_bit == 1 ? 1 << 2 : 0);
        g5_cdbaddr(&scmd->cdb.g5_cdb, lSector);
        g5_cdblen(&scmd->cdb.g5_cdb, SectorBurstVal);

        if (scgp->verbose) fprintf(stderr, "\nReadMatsushita12 CDDA...");

	scgp->cmdname = "Read12Matsushita";

  while (scsicmd(scgp) < 0
	 && count--)
    ;
  if (count < 0)
    FatalError ("Read CD-ROM12 (Matsushita) failed\n");
}

/* Read max. SectorBurst of cdda sectors to bufferCdda
   via MMC standard READ CD command */
void ReadCddaMMC12 (scgp, p, lSector, SectorBurstVal )
	SCSI *scgp;
	UINT4 *p;
	unsigned lSector;
	unsigned SectorBurstVal;
{
  int count = 0;
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)p;
        scmd->size = SectorBurstVal*CD_FRAMESIZE_RAW;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G5_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g5_cdb.cmd = 0xBE;
        scmd->cdb.g5_cdb.lun = scgp->lun;
        scmd->cdb.g5_cdb.res = 1 << 1; /* expected sector type field CDDA */
        g5_cdbaddr(&scmd->cdb.g5_cdb, lSector);
        g5x_cdblen(&scmd->cdb.g5_cdb, SectorBurstVal);
	scmd->cdb.g5_cdb.count[3] = 1 << 4;	/* User data */

        if (scgp->verbose) fprintf(stderr, "\nReadMMC12 CDDA...");

	scgp->cmdname = "ReadCD MMC 12";

  while (scsicmd(scgp) < 0
	 && count--)
    ;
  if (count < 0)
    FatalError ("ReadCD MMC 12 failed\n");
}

/* Read the Sub-Q-Channel to SubQbuffer */
#ifdef	PROTOTYPES
subq_chnl *ReadSubQSCSI (SCSI *scgp, unsigned char format, unsigned char track)
#else
subq_chnl *ReadSubQSCSI ( scgp, format, track )
	SCSI *scgp;
	unsigned char format;
	unsigned char track;
#endif
{
        int resp_size;
	register struct	scg_cmd	*scmd = scgp->scmd;

        switch (format) {
          case GET_POSITIONDATA:
            resp_size = 16;
          break;
          case GET_CATALOGNUMBER:
            resp_size = 24;
          break;
          case GET_TRACK_ISRC:
            resp_size = 24;
          break;
          default:
                fprintf(stderr, "ReadSubQSCSI: unknown format %d\n", format);
                return NULL;
        }

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->addr = (caddr_t)SubQbuffer;
        scmd->size = resp_size;
        scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
        scmd->cdb_len = SC_G1_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g1_cdb.cmd = 0x42;
        scmd->cdb.g1_cdb.res = 0;   /* was 1, problem with Pioneer drive */
        scmd->cdb.g1_cdb.lun = scgp->lun;
        scmd->cdb.g1_cdb.addr[0] = 0x40; /* request SubQ info */
        scmd->cdb.g1_cdb.addr[1] = format;
        scmd->cdb.g1_cdb.res6 = track;
        g1_cdblen(&scmd->cdb.g1_cdb, resp_size);

        if (scgp->verbose) fprintf(stderr, "\nRead Subchannel...");

	scgp->cmdname = "Read Subchannel";

  if (scsicmd(scgp))
    FatalError ("Read SubQ failed\n");

  return (subq_chnl *)(SubQbuffer); /* ignore warning, because the buffer is requested from malloc() */
}

/********* non standardized speed selects ***********************/

void SpeedSelectSCSIToshiba (scgp, speed)
	SCSI *scgp;
	unsigned speed;
{
  static unsigned char mode [4 + 3];
  unsigned char *page = mode + 4;
  int retval;

  if (speed != 1 && speed != 2) {
    fprintf(stderr, "invalid speed setting %d for Toshiba\n", speed);
    return;
  }

  fillbytes((caddr_t)mode, sizeof(mode), '\0');
  /* the first 4 mode bytes are zero. */
  page[0] = 0x20;
  page[1] = 1;
  page[2] = speed == 1 ? 0 : 1;   /* 0 for single speed */

  if (scgp->verbose) fprintf(stderr, "\nspeed select Toshiba...");
  /* do the scsi cmd */
  if ((retval = mode_select(scgp, mode, 7, 0, scgp->inq->data_format >= 2)) < 0)
        perror ("speed select Toshiba failed\n");
}

void SpeedSelectSCSINEC (scgp, speed)
	SCSI *scgp;
	unsigned speed;
{
  static unsigned char mode [4 + 8];
  unsigned char *page = mode + 4;
  int retval;
	register struct	scg_cmd	*scmd = scgp->scmd;

  if (speed != 1 && speed != 2) {
    fprintf(stderr, "invalid speed setting %d for NEC\n", speed);
    return;
  }

  fillbytes((caddr_t)mode, sizeof(mode), '\0');
  /* the first 4 mode bytes are zero. */
  page [0] = 0x0f; /* page code */
  page [1] = 6;    /* parameter length */
  /* bit 5 == 1 for single speed, otherwise double speed */
  page [2] = speed == 1 ? 1 << 5 : 0;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
  scmd->addr = (caddr_t)mode;
  scmd->size = 12;
  scmd->flags = SCG_DISRE_ENA;
  scmd->cdb_len = SC_G1_CDBLEN;
  scmd->sense_len = CCS_SENSE_LEN;
  scmd->target = scgp->target;
  scmd->cdb.g1_cdb.cmd = 0xC5;
  scmd->cdb.g1_cdb.lun = scgp->lun;
  scmd->cdb.g1_cdb.addr[0] = 0 ? 1 : 0 | 1 ? 0x10 : 0;
  g1_cdblen(&scmd->cdb.g1_cdb, 12);

  if (scgp->verbose) fprintf(stderr, "\nspeed select NEC...");
  /* do the scsi cmd */

	scgp->cmdname = "speed select NEC";

  if ((retval = scsicmd(scgp)) < 0)
        perror ("speed select NEC failed\n");
}

void SpeedSelectSCSIPhilipsCDD2600 (scgp, speed)
	SCSI *scgp;
	unsigned speed;
{
  /* MODE_SELECT, page = SCSI-2  save page disabled, reserved, reserved,
     parm list len, flags */
  static unsigned char mode [4 + 8];
  unsigned char *page = mode + 4;
  int retval;

  if (speed != 1 && speed != 2 && speed != 4) {
    fprintf(stderr, "invalid speed setting %d for Philips CDD2600\n", speed);
    return;
  }

  fillbytes((caddr_t)mode, sizeof(mode), '\0');
  /* the first 4 mode bytes are zero. */
  page[0] = 0x23;
  page[1] = 6;
  page[2] = page [4] = speed;
  page[3] = 1;

  if (scgp->verbose) fprintf(stderr, "\nspeed select Philips...");
  /* do the scsi cmd */
  if ((retval = mode_select(scgp, mode, 12, 0, scgp->inq->data_format >= 2)) < 0)
        perror ("speed select PhilipsCDD2600 failed\n");
}

void SpeedSelectSCSISony (scgp, speed)
	SCSI *scgp;
	unsigned speed;
{
  static unsigned char mode [4 + 4];
  unsigned char *page = mode + 4;
  int retval;

  /* speed values > 1 are drive dependent */
  if (speed > 4) speed = 8;

  fillbytes((caddr_t)mode, sizeof(mode), '\0');
  /* the first 4 mode bytes are zero. */
  page[0] = 0x31;
  page[1] = 2;
  page[2] = speed / 2;

  if (scgp->verbose) fprintf(stderr, "\nspeed select Sony...");
  /* do the scsi cmd */
  if ((retval = mode_select(scgp, mode, 8, 0, scgp->inq->data_format >= 2)) < 0)
        perror ("speed select Sony failed\n");
}

void SpeedSelectSCSIYamaha (scgp, speed)
	SCSI *scgp;
	unsigned speed;
{
  static unsigned char mode [4 + 4];
  unsigned char *page = mode + 4;
  int retval;

  /* speed values > 1 are drive dependent */
  if (speed > 4) speed = 8;

  fillbytes((caddr_t)mode, sizeof(mode), '\0');
  /* the first 4 mode bytes are zero. */
  page[0] = 0x31;
  page[1] = 2;
  page[2] = (speed / 2) << 4;

  if (scgp->verbose) fprintf(stderr, "\nspeed select Yamaha...");
  /* do the scsi cmd */
  if ((retval = mode_select(scgp, mode, 8, 0, scgp->inq->data_format >= 2)) < 0)
        perror ("speed select Yamaha failed\n");
}

void SpeedSelectSCSIMMC (scgp, speed)
	SCSI *scgp;
	unsigned speed;
{
  int spd;
	register struct	scg_cmd	*scmd = scgp->scmd;

   if (speed == 0) {
      spd = 0xFFFF;
   } else {
      spd = 176 * speed;
   }
	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
        scmd->flags = SCG_DISRE_ENA;
        scmd->cdb_len = SC_G5_CDBLEN;
        scmd->sense_len = CCS_SENSE_LEN;
        scmd->target = scgp->target;
        scmd->cdb.g5_cdb.cmd = 0xBB;
        scmd->cdb.g5_cdb.lun = scgp->lun;
        i_to_short(&scmd->cdb.g5_cdb.addr[0], spd);
        i_to_short(&scmd->cdb.g5_cdb.addr[2], spd);

        if (scgp->verbose) fprintf(stderr, "\nspeed select MMC...");

	scgp->cmdname = "set cd speed";

        if (scsicmd(scgp) < 0)
                perror ("speed select MMC failed\n");
}

/* request vendor brand and model */
unsigned char *Inquiry ( scgp )
	SCSI *scgp;
{
  static unsigned char *Inqbuffer = NULL;
	register struct	scg_cmd	*scmd = scgp->scmd;

  if (Inqbuffer == NULL) {
    Inqbuffer = (unsigned char *) malloc(42);
    if (Inqbuffer == NULL) {
      fprintf(stderr, "Cannot allocate memory for inquiry command in line %d\n", __LINE__);
        return NULL;
    }
  }

  fillbytes(Inqbuffer, 42, '\0');
	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
  scmd->addr = (caddr_t)Inqbuffer;
  scmd->size = 42;
  scmd->flags = SCG_RECV_DATA|SCG_DISRE_ENA;
  scmd->cdb_len = SC_G0_CDBLEN;
  scmd->sense_len = CCS_SENSE_LEN;
  scmd->target = scgp->target;
  scmd->cdb.g0_cdb.cmd = SC_INQUIRY;
  scmd->cdb.g0_cdb.lun = scgp->lun;
  scmd->cdb.g0_cdb.count = 42;
        
	scgp->cmdname = "inquiry";

  if (scsicmd(scgp) < 0)
     return (NULL);

  /* define structure with inquiry data */
  memcpy(scgp->inq, Inqbuffer, sizeof(*scgp->inq)); 

  if (scgp->verbose)
     scsiprbytes("Inquiry Data   :", (u_char *)Inqbuffer, 22 - scmd->resid);

  return (Inqbuffer);
}

#define SC_CLASS_EXTENDED_SENSE 0x07
#define TESTUNITREADY_CMD 0
#define TESTUNITREADY_CMDLEN 6

#define ADD_SENSECODE 12
#define ADD_SC_QUALIFIER 13
#define NO_MEDIA_SC 0x3a
#define NO_MEDIA_SCQ 0x00

int TestForMedium ( scgp )
	SCSI *scgp;
{
	register struct	scg_cmd	*scmd = scgp->scmd;

  if (interface != GENERIC_SCSI) {
    return 1;
  }

  /* request READY status */
	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
  scmd->addr = (caddr_t)0;
  scmd->size = 0;
  scmd->flags = SCG_DISRE_ENA | (1 ? SCG_SILENT:0);
  scmd->cdb_len = SC_G0_CDBLEN;
  scmd->sense_len = CCS_SENSE_LEN;
  scmd->target = scgp->target;
  scmd->cdb.g0_cdb.cmd = SC_TEST_UNIT_READY;
  scmd->cdb.g0_cdb.lun = scgp->lun;
        
  if (scgp->verbose) fprintf(stderr, "\ntest unit ready...");
  scgp->silent++;

	scgp->cmdname = "test unit ready";

  if (0 < scsicmd(scgp)) {
    scgp->silent--;
    return 1;
  }
  scgp->silent--;

  if (scmd->sense.code >= SC_CLASS_EXTENDED_SENSE) {
    return 
      scmd->u_sense.cmd_sense[ADD_SENSECODE] != NO_MEDIA_SC ||
      scmd->u_sense.cmd_sense[ADD_SC_QUALIFIER] != NO_MEDIA_SCQ;
  } else {
    /* analyse status. */
    /* 'check condition' is interpreted as not ready. */
    return (scmd->u_scb.cmd_scb[0] & 0x1e) != 0x02;
  }
}

int Play_atSCSI ( scgp, from_sector, sectors)
	SCSI *scgp;
	unsigned int from_sector;
	unsigned int sectors;
{
	register struct	scg_cmd	*scmd = scgp->scmd;

	fillbytes((caddr_t)scmd, sizeof(*scmd), '\0');
  scmd->addr = NULL;
  scmd->size = 0;
  scmd->flags = SCG_DISRE_ENA;
  scmd->cdb_len = SC_G1_CDBLEN;
  scmd->sense_len = CCS_SENSE_LEN;
  scmd->target = scgp->target;
  scmd->cdb.g1_cdb.cmd = 0x47;
  scmd->cdb.g1_cdb.lun = scgp->lun;
  scmd->cdb.g1_cdb.addr[1] = (from_sector + 150) / (60*75);
  scmd->cdb.g1_cdb.addr[2] = ((from_sector + 150) / 75) % 60;
  scmd->cdb.g1_cdb.addr[3] = (from_sector + 150) % 75;
  scmd->cdb.g1_cdb.res6 = (from_sector + 150 + sectors) / (60*75);
  scmd->cdb.g1_cdb.count[0] = ((from_sector + 150 + sectors) / 75) % 60;
  scmd->cdb.g1_cdb.count[1] = (from_sector + 150 + sectors) % 75;

  if (scgp->verbose) fprintf(stderr, "\nplay sectors...");
  /* do the scsi cmd */

	scgp->cmdname = "play sectors";

  return scsicmd(scgp) > 0 ? -1 : 0;
}
